!---------------------------------------------------------------------
!     Copyright (C) GFD Dennou Club, 2004. All rights reserved.
!---------------------------------------------------------------------
                                                                 !=begin
!= Subroutine DensityCloud
!
!   * Developer: Kitamori Taichi
!   * Version: $Id: densitycloud_precipitation.f90,v 1.1 2009-03-05 05:39:42 yamasita Exp $ 
!   * Tag Name: $Name: arare4-20110302-3 $
!   * Change History: 
!
!== Overview 
!
!̩٤λȯŸ
!
!== Error Handling
!
!== Known Bugs
!
!== Note
!
!   * եå򤤤Ƥ
!   * ήȻ, ǴϴޤޤƤʤ 
!   * γνθ
!  
!== Future Plans
!
                                                                 !=end
subroutine DensityCloud(      & 
  & xz_DensCloud_in,                 & !(in) ̩
  & DelTime,                         & !(in) leapfrog λֳִ
  & pz_VelXNl,                      & !(in) ʿή®
  & xr_VelZNl,                      & !(in) ľή®
  & xz_PotTempNl,                   & !(in) ̾
  & xz_ExnerNl,                     & !(in) ʡ
  & xz_DensCloudNl,                 & !(in) ̩
  & xz_RadiCloud,                   & !(in) γȾ
  & xz_MasscondNl,                  & !(inout) ŷ
  & xz_DensCloud_out)                  !(out) ̩

                                                                 !=begin  
  !== Dependancy
  use dc_trace, only: BeginSub, EndSub, DbgMessage
  use gridset,  only: DimXMin, DimXMax, DimZMin, DimZMax
!  use bcset,    only: xz_BC
  use average,  only: pz_avr_xz, xr_avr_xz
  use differentiate_center4, only: xz_dx_pz, xz_dz_xr
  use basicset, only: Grav, PressSfc, GasRDry, CpDry, &
               &      xz_ExnerBasicZ, xz_PotTempBasicZ
  use cloudset, only: DensIce

                                                                 !=end
  !== ۤηػ
  implicit none
                                                                 !=begin
  !== Input
  real(8), intent(in)  :: DelTime       ! leapfrog λֳִ [s]
  real(8), intent(in)  :: xz_DensCloud_in(DimXMin:DimXMax, DimZMin:DimZMax)
                                        ! ̩ [kg/m^3]
  real(8), intent(in)  :: pz_VelXNl(DimXMin:DimXMax, DimZMin:DimZMax)
                                        ! ʿ® [m/s]
  real(8), intent(in)  :: xr_VelZNl(DimXMin:DimXMax, DimZMin:DimZMax)
                                        ! ľ® [m/s]
  real(8), intent(in)  :: xz_DensCloudNl(DimXMin:DimXMax, DimZMin:DimZMax)
                                        ! ̩ [kg/m^3]
  real(8), intent(in)  :: xz_RadiCloud(DimXMin:DimXMax, DimZMin:DimZMax)  
                                        ! γȾ [m]
  real(8), intent(in)  :: xz_ExnerNl(DimXMin:DimXMax, DimZMin:DimZMax)  
                                        ! ʡؿξʬ [1]
  real(8), intent(in)  :: xz_PotTempNl(DimXMin:DimXMax, DimZMin:DimZMax)  
                                        ! ̤ξʬ [K]

  !== Output
  real(8), intent(out)  :: xz_DensCloud_out(DimXMin:DimXMax, DimZMin:DimZMax)
                                        ! ̩ [kg/m^3]

  !== In/Out
  real(8), intent(inout):: xz_MasscondNl(DimXMin:DimXMax, DimZMin:DimZMax)
                                        ! ŷ [kg/m^3 s]
                                                                 !=end  
  !== Work
  real(8)  :: xz_FluxDensCloud(DimXMin:DimXMax, DimZMin:DimZMax) 
                                        ! եåˤ̩٤λѲΨ [kg/m^3 s]
  real(8)  :: xz_SrcDensCloud(DimXMin:DimXMax, DimZMin:DimZMax)
                                        ! Ǥˤ̩٤λѲΨ [kg/m^3 s]
  real(8)  :: xz_PrecipDensCloud(DimXMin:DimXMax, DimZMin:DimZMax)
                                        ! ˤ̩٤λѲΨ [kg/m^3 s]
  real(8)  :: xz_TermVel(DimXMin:DimXMax, DimZMin:DimZMax)
                                        ! γνü®
  real(8)  :: xz_VisCoffCO2(DimXMin:DimXMax, DimZMin:DimZMax)
                                        ! CO2 Ǵ
  real(8)  :: xz_MeanFreePath(DimXMin:DimXMax, DimZMin:DimZMax)
                                        ! CO2 ʿѼͳ
  real, parameter :: Pi = 3.1415926535897932385d0
                                        ! ߼Ψ
  real, parameter :: BoltzmannConst = 1.38065d-23
                                        ! ܥĥޥ
  real, parameter :: CO2Diam = 3.30d-10
                                        ! CO2 ʬҤ kinetic diameter
  real, parameter :: SutherlandConst = 2.40d2
                                        ! CO2 ʬҤΥ
  real, parameter :: VisCoffConst = 1.47d-5
                                        ! 1 , 20 ٤ǤCO2 ʬҤǴ


  call BeginSub("DensityCloud", &
       &        fmt="%c",              &
       &        c1="Time integration of density of cloud.")
  
!  write(*,*) xz_DensCloudNl(1,:)

  !=== Ǵη׻
  xz_VisCoffCO2 = &
    & VisCoffConst * (293.15d0 + SutherlandConst) &
    & / ( (xz_PotTempBasicZ + xz_PotTempNl)*(xz_ExnerBasicZ + xz_ExnerNl) &
    &     + SutherlandConst ) &
    & * ( (xz_PotTempBasicZ + xz_PotTempNl)*(xz_ExnerBasicZ + xz_ExnerNl) &
    &     / 293.15d0 )**1.5d0
  !=== ʿѼͳη׻
  xz_MeanFreePath = &
    & BoltzMannConst * &
    & (xz_PotTempBasicZ + xz_PotTempNl)*(xz_ExnerBasicZ + xz_ExnerNl) &
    & / ( 2.0**0.5d0 * Pi * (CO2Diam)**2.0d0 * PressSfc &
    &    * (xz_ExnerBasicZ + xz_ExnerNl)**(CpDry/GasRDry) )

  !=== ü®٤η׻
  xz_TermVel = &
    & 2.0d0 * Grav * DensIce * xz_DensCloudNl  &
    & * (xz_RadiCloud + 1.255d0 * xz_MeanFreePath ) &
    & / (9.0d0 * xz_VisCoffCO2)

  !=== η׻. 4 濴ʬѤƷ׻
  xz_PrecipDensCloud  = &
    & xz_dz_xr(xr_avr_xz(xz_TermVel) * xr_avr_xz(xz_DensCloudNl))


  !=== եåη׻. 4 濴ʬѤƷ׻
  xz_FluxDensCloud  = &
    & - xz_dx_pz(pz_VelXNl * pz_avr_xz(xz_DensCloudNl)) &
    & - xz_dz_xr(xr_VelZNl * xr_avr_xz(xz_DensCloudNl))


  call DbgMessage( fmt="*** Debug Message [DensityCloud] *** xz_SrcDensCloud ")

  !=== η׻
  xz_SrcDensCloud = xz_MasscondNl

  call DbgMessage( fmt="*** Debug Message [DensityCloud] *** xz_DensCloud_out ")

  xz_DensCloud_out = xz_DensCloud_in  & 
    & + DelTime * (xz_PrecipDensCloud + xz_FluxDensCloud + xz_SrcDensCloud)

  call DbgMessage( fmt="*** Debug Message [DensityCloud] *** xz_DensCloud_out(adjustment) ")

  ! ̤ˤʤ 0 ˤ. 
  ! ʬȯ̤򸺤餹
  xz_DensCloud_out = max(xz_DensCloud_out, 0.0d0)
  xz_MasscondNl = max(xz_MasscondNl,   &
    &  - (xz_DensCloudNl / DelTime  + xz_PrecipDensCloud + xz_FluxDensCloud))

!  !=== 
!  call boundary(xz_BC, xz_DensCloud_out)
!
  call EndSub("DensityCloud")
  
end subroutine DensityCloud
